/*
 *  1541fs.cpp - 1541 emulation in host file system
 *
 *  Frodo (C) 1994-1997,2002 Christian Bauer

 *
 * Notes:
 * ------
 *
 *  - If the directory is opened (file name "$"), a temporary file
 *    with the structure of a 1541 directory file is created and
 *    opened. It can then be accessed in the same way as all other
 *    files.
 *
 * Incompatibilities:
 * ------------------
 *
 *  - No "raw" directory reading
 *  - No relative/sequential/user files
 *  - Only "I" and "UJ" commands implemented
 */

#include "sysdeps.h"
#include "1541fs.h"
#include "IEC.h"
#include "main.h"
#include "Prefs.h"


// Access modes
enum {
	FMODE_READ, FMODE_WRITE, FMODE_APPEND
};

// File types
enum {
	FTYPE_PRG, FTYPE_SEQ
};

// Prototypes
//static bool match(char *p, char *n);


/*
 *  Constructor: Prepare emulation
 */

FSDrive::FSDrive(C64 *c64, IEC *iec, FILE *f) : Drive(c64, iec) { }
uint8 FSDrive::Open(int x, char *s) { return 0;}
uint8 FSDrive::Close(int x) { return 0; }
uint8 FSDrive::Read(int x, unsigned char *s) { return 0; }
uint8 FSDrive::Write(int x, unsigned char c, bool b) {return 0;}
void FSDrive::Reset() {}
