#ifndef _PALMHELPER_H
#define _PALMHELPER_H

// Macros to switch between endians
#define SWAP32(x) (((((UInt32)(x))&0x000000ffL)<<24) | \
                   ((((UInt32)(x))&0x0000ff00L)<< 8) | \
                   ((((UInt32)(x))&0x00ff0000L)>> 8) | \
                   ((((UInt32)(x))&0xff000000L)>>24))
#define SWAP16(x) (((((UInt16)(x))&0x00ff)<<8) | \
                   ((((UInt16)(x))&0xff00)>>8))


//these should be better than macros since argument is evaluated only once
static inline UInt32 swap32(UInt32 l){
	return SWAP32(l);
}
	
static inline UInt16 swap16(UInt16 l){
	return SWAP16(l);
}


// Procedures for display error and debug info
void ShowInfo(char *s);
void ShowInfoRes(DmResID lID);
void ShowDebug(char *s);
void ShowError(char *strMessage);
void ShowErrorRes(DmResID lID);
void ShowErrorResStr(DmResID lID, char *strParam);
void ShowErrorResLong(DmResID lID, int32 lParam);
UInt16 AskUserDialog(char *strQuestion);


// Procedures to handle resources and memory
MemPtr NewSwapped(UInt32);
void FreeSwapped(MemPtr);
MemPtr GetRes(DmResType, UInt32, char *);
void UngetRes(MemPtr);
MemPtr CopyRes(DmResType, UInt32, char *);
MemPtr CopyRes2(DmResType, UInt32, char *, int);
void UncopyRes(MemPtr);
MemPtr LoadRes(DmResType t, UInt32 idx, char *name);


#endif
