//
//  ZipHandler.java
//  C64Palmer
//
//  Created by Johan Forsberg on Thu Aug 28 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.io.*;
import java.util.zip.*;
import java.util.*;

public class ZipHandler {
    D64Handler d64=new D64Handler();
    T64Handler t64=new T64Handler();
    
    public List handle(File f) {
        ZipFile z;
        
        try {
            z=new ZipFile(f);
        } catch (Exception x) {
            return null;
        }
        List l=new ArrayList();
        
        Enumeration e=z.entries();
        while (e.hasMoreElements()) {
            Object o=e.nextElement();
            if (!(o instanceof ZipEntry))
                continue;
            
            ZipEntry en=(ZipEntry) o;
            String n=en.getName();
	    if (n==null || n.length()<4) continue;
	    String ext=n.substring(n.length()-4);
            if (!ext.equalsIgnoreCase(".d64") && !ext.equalsIgnoreCase(".t64"))
                continue;
            
            PDBItem item=null;
            byte b[]=new byte[1024];
            ByteArrayOutputStream baos=new ByteArrayOutputStream();
            
            try {
                int len;
                InputStream is=z.getInputStream(en);
                if (is==null) {
                    System.err.println("Couldn't get InputStream for ZipEntry "+en.getName());
                    continue;
                }
                while ((len=is.read(b))>0)
                    baos.write(b, 0, len);
                b=baos.toByteArray();
            } catch (Exception x) {
                b=null;
                x.printStackTrace();
            }
            
            if (b==null) continue;
            
            if (ext.equalsIgnoreCase(".d64")) {
                item=d64.handle(n, b);
            } else {
                item=t64.handle(n, b);
            }
            if (item!=null)
                l.add(item);
        }
        if (l.size()==0)
            return null;
        
        return l;
    }
}
